"use strict";
/* eslint-disable canonical/filename-match-regex */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FSWatcher = void 0;
const FileWatchingBackend_1 = require("./FileWatchingBackend");
const node_fs_1 = __importDefault(require("node:fs"));
const node_path_1 = __importDefault(require("node:path"));
class FSWatcher extends FileWatchingBackend_1.FileWatchingBackend {
    constructor(project) {
        super();
        this.fsWatcher = node_fs_1.default.watch(project, {
            encoding: 'utf8',
            persistent: true,
            recursive: true,
        }, (eventType, filename) => {
            this.emit('change', { filename: node_path_1.default.resolve(project, filename) });
        });
        setImmediate(() => {
            this.emit('ready');
        });
    }
    async close() {
        this.fsWatcher.close();
    }
}
exports.FSWatcher = FSWatcher;
//# sourceMappingURL=FSWatcher.js.map